/*
 * 爱组搭，低代码组件化开发平台
 * ------------------------------------------
 * 受知识产权保护，请勿删除版权申明，开发平台不允许做非法网站，后果自负
 */
package com.aizuda.generator;

import com.aizuda.core.bean.BaseEntity;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.generator.FastAutoGenerator;
import com.baomidou.mybatisplus.generator.config.TemplateType;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.fill.Column;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * 代码自动生成器
 *
 * @author 青苗
 * @since 2021-10-31
 */
public class CodeGenerator {

    /**
     * 执行生成
     *
     * @param url              数据库连接地址
     * @param username         数据库名称
     * @param password         数据库密码
     * @param parent           父包
     * @param entitySuperClass 实体父类
     */
    public static void execute(String url, String username, String password, String parent,
                               Class<?> entitySuperClass) {
        // 代码生成
        FastAutoGenerator.create(url, username, password)
                // 全局配置
                .globalConfig((scanner, builder) -> builder.author(scanner.apply("请输入作者名称？"))
                        .outputDir("C://aizuda-code").dateType(DateType.ONLY_DATE)
                        .enableSwagger())
                // 包配置
                .packageConfig(builder -> builder.parent(parent))
                // 模板配置
                .templateConfig(builder -> builder.disable(TemplateType.XML))
                // 策略配置
                .strategyConfig((scanner, builder) -> builder.addInclude(getTables(scanner.apply("请输入表名，多个英文逗号分隔？所有输入 all")))
                        .controllerBuilder().enableRestStyle().enableHyphenStyle()
                        .serviceBuilder().superServiceClass("com.aizuda.service.service.IBaseService")
                        .mapperBuilder().superClass("com.aizuda.service.mapper.CrudMapper")
                        .entityBuilder().enableLombok().disableSerialVersionUID().addTableFills(
                                new Column("create_id", FieldFill.INSERT),
                                new Column("create_by", FieldFill.INSERT),
                                new Column("create_time", FieldFill.INSERT),
                                new Column("update_by", FieldFill.UPDATE),
                                new Column("update_time", FieldFill.UPDATE)
                        ).addSuperEntityColumns("id", "create_id", "create_by", "create_time",
                                "update_by", "update_time", "deleted")
                        .logicDeleteColumnName("deleted")
                        .superClass(entitySuperClass)
                        .build())
                // 模板渲染引擎
                .templateEngine(new CodeTemplateEngine())
                // 执行
                .execute();
    }

    public static void execute(String url, String username, String password, String parent) {
        execute(url, username, password, parent, BaseEntity.class);
    }

    protected static List<String> getTables(String tables) {
        return "all".equals(tables) ? Collections.emptyList() : Arrays.asList(tables.split(","));
    }
}
